#include <stdio.h>
#include <fcntl.h>

#define  PERMS 0666

main(int argc, char *argv[])
{
	void	fatal(char *);
	int	source, object;
	int	read_number;
	char	buff[BUFSIZ];


	if(argc < 2)
		{
		puts(" : a.out source object");
		exit(0);
		}

	if((source = open(argv[1], O_RDONLY)) < 0)
		fatal("read open");
	if((object = open(argv[2], O_WRONLY | O_CREAT | O_TRUNC, PERMS)) < 0)
		fatal("write open");

	while((read_number = read(source, buff, BUFSIZ)) > 0)
		{
		if(write(object, buff, read_number) < read_number)
			{
			close(source);
			close(object);
			exit(1);
			}
		}

	close(source);
	close(object);
}

void
fatal(char *error_name)
{
	perror(error_name);
	exit(1);
}
