#include <stdio.h>

#define  SAME		1
#define  NOT_SAME	0

#define  C_OPTION	1

main(int argc, char *argv[])
{
	void	fatal(char *);
	void	get_line(FILE *, char *);
	int	compare_line(char *, char *);
	FILE	*fp;
	int	c;
	int	count = 0;
	int	result = 0;
	int	OPTION = 0;
	int	count_same = 1;
	char	before_line[BUFSIZ];
	char	current_line[BUFSIZ] = "";
	char	same_buff[BUFSIZ] = "";
	char	buff[BUFSIZ] = "";


	if(argc < 2)
		{
		puts("usage : a.out [-c] file");
		exit(0);
		}

	argv++;

	if(!strcmp(*argv, "-c"))
		{
		OPTION = C_OPTION;
		argv++;
		}
	else	if(**argv == '-')
		{
		puts("usage : a.out [-c] file");
		exit(0);
		}

	do	{
	if((fp = fopen(*argv, "r")) == NULL)
		fatal("fopen");

	get_line(fp, before_line);

	while((c = getc(fp)) != EOF)
		{
		if(c == '\n')
			{
			current_line[count] = '\0';
			count = 0;
			result =
				compare_line(before_line, current_line);
			if(result == SAME)
				{
				count_same++;
				strcpy(same_buff, current_line);
				result = NOT_SAME;
				}
			else	{ /* not same */
				if(strcmp(same_buff, ""))
					{
					strcpy(buff, same_buff);
					strcpy(same_buff, "");
					}
				else	strcpy(buff, before_line);

				if(OPTION == C_OPTION)
					printf("\t%d %s\n",
						count_same, buff);
				else	printf("%s\n", buff);
						
				count_same = 1;
				}
				
			strcpy(before_line, current_line);
			continue;
			}

		current_line[count++] = c;

		}
	if(!strcmp(current_line, ""))
		strcpy(buff, before_line);
	else	strcpy(buff, current_line);

	if(OPTION == C_OPTION)
		printf("\t%d %s\n", count_same, buff);
	else	printf("%s\n", buff);

	fclose(fp);
	} while(*++argv);
}

void
get_line(FILE *fp, char *before_line)
{
	int	c;
	int	count = 0;


	while((c = getc(fp)) != EOF)
		{
		if(c == '\n')
			break;
		before_line[count++] = c;
		}

	before_line[count] = '\0';
}

int
compare_line(char *before_line, char *current_line)
{
	if(strlen(before_line) != strlen(current_line))
		return NOT_SAME;
	while(*before_line)
		if(*before_line++ != *current_line++)
			return NOT_SAME;

	return SAME;
}

void
fatal(char *error_name)
{
	perror(error_name);
	exit(1);
}
