#include <stdio.h>
#include <dirent.h>
#include <sys/stat.h>

#define  ON	1
#define  OFF	0

#define  TRUE	1
#define  FALSE	0

#define  LEFT_STAR	1
#define  MIDDLE_STAR	2
#define  RIGHT_STAR	3


time_t	now;
int	extention = LEFT_STAR;
int	option_count;
char	pattern[BUFSIZ];


struct	option_t {
	char	*name;
	char	*value;
};

struct	option_t *option[10];
int	option_count;

main(int argc, char *argv[])
{

	void	check_match(DIR  *, char *);
	void	fatal(char *);
	struct	option_t *parse_option(char **);
	char	path_name[BUFSIZ];
	char	object[BUFSIZ];
	char	user_time[10];
	struct	stat source_stat;
	DIR	*dir;
	int	count;
	int	imsi = 0;
	char	**imsi_argv;


	if(argc < 3)
		{
		puts(" : % a.out directory_name pattern");
		exit(0);
		}

	imsi_argv = argv;
	time(&now);

	/* find . -name "*c" -print */
	/* ɼ ̾  */
	while(*++argv)
	{
	if(!strncmp(*argv, "-", 1))
		{
		option[option_count] = parse_option(argv);
		option_count++;
		}

	}

	/* ɼ ߿  ̾ . */
	while(option[imsi])
		{
		if(!strcmp(option[imsi]->name, "name"))
			{
			if(strchr(option[imsi]->value, '*'))
				{
				if(!strncmp(option[imsi]->value, "*", 1))
				{
				strcpy(pattern, option[imsi]->value + 1);
				extention = LEFT_STAR;
				}
				else	if(strrchr(option[imsi]->value, '*'))
					extention = RIGHT_STAR;
				else	extention = MIDDLE_STAR;
				}
			else	strcpy(pattern, option[imsi]->value);

			break;
			}
		imsi++;
		}

	while(strncmp(*++imsi_argv, "-", 1))
	{
	if(stat(*imsi_argv, &source_stat) < 0)
		fatal("source stat");
	
	if(!S_ISDIR(source_stat.st_mode & S_IFMT))
		{
		printf("%s is not directory\n", *imsi_argv);
		exit(0);
		}
	if((dir = opendir(*imsi_argv)) == NULL)
		fatal("opendir");
	check_match(dir, *imsi_argv);
	}
	

}

void
check_match(DIR *dir, char *path_name)
{
	void	fatal(char *);
	int	check_atime(char *, char *);
	int	check_mtime(char *, char *);
	int	check_ctime(char *, char *);
	int	check_type(char *, char *);

	struct	dirent	*directory;
	struct	stat	file_stat;
	char	path_name_buff[BUFSIZ];
	int	count;
	int	result = FALSE;
	int	source_size, pattern_size, size_gab;




	while(directory = readdir(dir))
	{
	if(!strncmp(directory->d_name, ".", 1))
		continue;
	if(directory->d_ino == 0)
		continue;

	sprintf(path_name_buff, "%s/%s", path_name, directory->d_name);
	if(lstat(path_name_buff, &file_stat) < 0)
		fatal("stat");

	if(S_ISDIR(file_stat.st_mode & S_IFMT))
		{
		DIR	*imsi_dir;

		if((imsi_dir = opendir(path_name_buff)) < 0)
			fatal("opendir");
		check_match(imsi_dir, path_name_buff);
		}

	switch(extention)
	{
	case    LEFT_STAR :
		source_size = strlen(directory->d_name);
		pattern_size = strlen(pattern);	
			
		size_gab = source_size - pattern_size;

		if(size_gab < 0) continue;

		if(!strcmp(directory->d_name + size_gab, pattern))
			break;
		else    continue;
	case    MIDDLE_STAR : break;
	case    RIGHT_STAR  : break;
	}

	count = 0;
	while(option[count])
	{
	if(!strcmp(option[count]->name, "atime"))
		{
		result = check_atime(path_name_buff, option[count]->value);
		if(result == TRUE) puts(path_name_buff);
		result = FALSE;
		}
	if(!strcmp(option[count]->name, "mtime"))
		{
		result = check_mtime(path_name_buff, option[count]->value);
		if(result == TRUE) puts(path_name_buff);
		result = FALSE;
		}
	if(!strcmp(option[count]->name, "ctime"))
		{
		result = check_ctime(path_name_buff, option[count]->value);
		if(result == TRUE) puts(path_name_buff);
		result = FALSE;
		}
	if(!strcmp(option[count]->name, "type"))
		{
		result = check_type(path_name_buff, option[count]->value);
		if(result == TRUE) puts(path_name_buff);
		result = FALSE;
		}
	count++;
	} /* while(option[count]) */
	} /* while(directory = readdir(dir)) */

	closedir(dir);
}

void
fatal(char *error_name)
{
	perror(error_name);
	exit(1);
}

struct option_t *
parse_option(char **options)
{
	option[option_count] = 
		(struct option_t *)malloc(sizeof(struct option_t));

	option[option_count]->name = *options + 1;
	option[option_count]->value = *(options + 1);

	return option[option_count];
}

int
check_atime(char *file, char *user_time)
{
	time_t	current, old;
	struct	stat file_stat;
	
	lstat(file, &file_stat);
	current = now / 86400;	
	old = file_stat.st_atime/86400;

	if(strchr(user_time, '-'))
		{
	if((current - old) <= atoi(strchr(user_time, '-') + 1))
		return TRUE;

	} else  if((current - old) == atoi(user_time))
		return TRUE;

	return FALSE;
}

int
check_mtime(char *file, char *user_time)
{
	time_t	current, old;
	struct	stat file_stat;
	
	lstat(file, &file_stat);
	current = now / 86400;	
	old = file_stat.st_mtime/86400;

	if(strchr(user_time, '-'))
		{
	if((current - old) <= atoi(strchr(user_time, '-') + 1))
		return TRUE;

	} else  if((current - old) == atoi(user_time))
		return TRUE;

	return FALSE;
}
int
check_ctime(char *file, char *user_time)
{
	time_t	current, old;
	struct	stat file_stat;
	
	lstat(file, &file_stat);
	current = now / 86400;	
	old = file_stat.st_ctime/86400;

	if(strchr(user_time, '-'))
		{
	if((current - old) <= atoi(strchr(user_time, '-') + 1))
		return TRUE;

	} else  if((current - old) == atoi(user_time))
		return TRUE;

	return FALSE;
}
int
check_type(char *file)
{
}
