#include <stdio.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <netinet/in.h>

#define  FOREVER while(1)
#define  SIZE 8

main(int argc, char *argv[])
{
	void	Print(char *, double);
	void	fatal(char *);
	struct	sockaddr_in server;
	char	*server_IP;
	char	receive_string[BUFSIZ + 1];
	int	receive_length;
	int	server_port;
	int	server_fd;
	double	imsi_load_1;
	double	imsi_load_5;
	double	imsi_load_15;
	double	imsi_cpu;
	double	imsi_user;
	double	imsi_kernel;
	double	imsi_iowait;
	double	imsi_swap;
	double	imsi_memory;

	static	int count;

	char	load_1 [SIZE];
	char	load_5 [SIZE];
	char	load_15[SIZE];
	char	cpu    [SIZE];
	char	user   [SIZE];
	char	kernel [SIZE];
	char	iowait [SIZE];
	char	swap   [SIZE];
	char	memory [SIZE];
	int	imsi;
	

	if(argc != 2)
		{
		puts("usage : client IP_address");
		exit(0);
		}

	server_IP = argv[1];
	server_port = 4999;

	if((server_fd = socket(AF_INET, SOCK_STREAM, 0)) < 0)
		fatal("socket");

	bzero((char *)&server, sizeof(server));
	server.sin_family = AF_INET;
	server.sin_addr.s_addr = inet_addr(server_IP);
	server.sin_port = htons(server_port);

	if(connect(server_fd, (struct sockaddr *)&server, sizeof(server)) < 0)
		fatal("connect");
	puts("connectd.");

	FOREVER
		{
		receive_length = read(server_fd, receive_string, BUFSIZ);
		receive_string[receive_length] = '\0';
		if(count == 0) { count = 1; continue; }
		sscanf(receive_string, "%*s %*s %*s %*s %*s"
			"%s %s %s"
			"%s %s %s %s %s"
			"%s",
			load_1, load_5, load_15,
			cpu, user, kernel, iowait, swap,
			memory);
		puts("----+----------------------------------"
		"---------------------------------------");
		printf("     %7s %7s %7s "
			"%7s %7s %7s %7s %7s "
			"%7s\n",
			"load  1", "load  5", "load 15",
			"cpu", "user", "kernel", "iowait", "swap",
			"memory");
		printf("     %7s %7s %7s "
			"%7s %7s %7s %7s %7s "
			"%7s\n",
			load_1, load_5, load_15,
			cpu, user, kernel, iowait, swap,
			memory);
		imsi_load_1 = atof(load_1);
		imsi_load_5 = atof(load_5);
		imsi_load_15 = atof(load_15);
		imsi_cpu = atof(cpu);
		imsi_user = atof(user);
		imsi_kernel = atof(kernel);
		imsi_iowait = atof(iowait);
		imsi_swap = atof(swap);
		imsi_memory = atof(memory);
			
		puts("----+----------------------------------"
		"---------------------------------------");

		Print("load 1", imsi_load_1);
		Print("load 5", imsi_load_5);
		Print("load 15", imsi_load_15);
		Print("cpu", imsi_cpu);
		Print("user", imsi_user);
		Print("kernel", imsi_kernel);
		Print("iowait", imsi_iowait);
		Print("swap", imsi_swap);
		Print("memory", imsi_memory);

		}

	close(server_fd);
}

void
Print(char *title, double info)
{
	int	imsi;
	int	i;

	if(strcmp(title, "load 1") || strcmp(title, "load 5") ||
		strcmp(title, "load 15"))
		{
			printf("%s\t| %5.2f\t|", title, info);
			imsi = (int)(info / 2.);
			for(i = 0;i < imsi;i++)
				putchar('*');
		}
	else	{
			printf("%s\t| %5.1f\t|", title, info);
			imsi = (int)(info / 2.);
			for(i = 0;i < imsi;i++)
				putchar('*');
		}

	puts("");
}
		
void
fatal(char *error_name)
{
	perror(error_name);
	exit(1);
}
